﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 합계 구하기 - GetSummary(sourceEnumerable)

        /// <summary>
        /// 합계 구하기
        /// </summary>
        /// <param name="sourceEnumerable">소스 열거 가능형</param>
        /// <returns>합계</returns>
        private static int GetSummary(IEnumerable<int> sourceEnumerable)
        {
            int result = sourceEnumerable.AsParallel().Aggregate
            (
                seed : 0,
                func : (summary, item) => summary + item
            );

            return result;
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main(string[] argumentArray)
        {
            int[] valueArray = new int[] { 10, 20, 30, 20, 10, 30, 40 , 50 };

            int summrary = GetSummary(valueArray);

            Console.WriteLine(summrary);
        }

        #endregion
    }
}